public class Competitor {
    private String numberSign;
    private int score;
    private int time;

    public Competitor (int number, int score, int min, int sec) {
        if ((number > 0 && number <= 100) && (score >= 0 && score <= 50) && (sec >= 0 && sec <= 60) && (min >= 0 && min <= 60)) {
            this.numberSign = "No" + number;
        }
        this.score = score;
        this.time = min * 60 + sec;       
    } 

    public String toString () {
        StringBuilder result = new StringBuilder("(");
        if (this.numberSign != null) {
            result.append(this.numberSign);
        } else {
            result.append("-invalide-");
        }
        result.append(", ");
        result.append(this.score);
        result.append(" points, ");
        result.append(this.time);
        result.append("s)");

        return result.toString();
    }

    public boolean isValid() {
        return this.numberSign != null;
    }

    public boolean equals(Competitor other) {
        if (this == other) {
            return true;
        }
        if (other == null) {
            return false;
        }
        return (this.numberSign.equals(other.numberSign) && this.score == other.score);
    }

    public boolean isFaster(Competitor other) {
        if (other == null) {
            return true;
        }
        return (this.time < other.time);
    }
}
